showTree([Wurzel|Bs],Einrueckung) :-
    tab(Einrueckung), writeq(Wurzel),
    (Bs = [[Blatt]] -> tab(1), writeq(Blatt)
    ; Einrueckung2 is Einrueckung + 3,
        showTrees(Bs,Einrueckung2)).
showTree([],Einrueckung) :-
    tab(Einrueckung), writeq([]).

showTrees([Baum|Baeume],Einrueckung) :-
    nl,showTree(Baum,Einrueckung),
    showTrees(Baeume,Einrueckung).
showTrees([],_).

/* nur erste Lesart:
writeTrLam([Wurzel|Bs],Einrueckung) :-
    (sem([Wurzel|Bs],LamTerm) % 2.sem.Lesarten?
     -> (debugging(typisieren)
        -> type([],LamTerm,LamTermGetypt,Typ),
            Term = (LamTermGetypt:Typ)
        ; Term=LamTerm),
        tab(Einrueckung),writeq(Wurzel),
        nl,tab(Einrueckung),write('+ '),writen(Term)
    ; tab(Einrueckung),writeq(Wurzel)), % Wörter ohne Bedeutung
    (Bs = [[Blatt]] 
    -> tab(1), writeq(Blatt)
    ; Einrueckung2 is Einrueckung + 3,
        writeTrsLam(Bs,Einrueckung2)
    ). */
writeTrLam([Wurzel|Bs],Einrueckung) :-
    ( sem([Wurzel|Bs],_)  % Ausdruck mit Bedeutungen
    ->  % schreibe alle Bedeutungen unter die Wurzel
        tab(Einrueckung),writeq(Wurzel),
        (Bs = [[Blatt]] -> tab(1), writeq(Blatt) ; true),
        (sem([Wurzel|Bs],LamTerm),
            (nl,tab(Einrueckung),write('+ '),writen(LamTerm)),
            fail             
        ; true)
    ; % schreibe das bedeutungslose Wort
      tab(Einrueckung),writeq(Wurzel) ),   
    ( Bs = [[Blatt]] -> true % schon geschrieben
    ; Einrueckung2 is Einrueckung + 3,
        writeTrsLam(Bs,Einrueckung2) ).
writeTrLam([],Einrueckung) :-
    tab(Einrueckung), writeq([]).
    
writeTrsLam([Baum|Baeume],Einrueckung) :-
    nl,writeTrLam(Baum,Einrueckung),
    writeTrsLam(Baeume,Einrueckung).
writeTrsLam([],_).

writen(Term) :- \+ \+((numbervars(Term,23,_),
           write_term(Term,[numbervars(true)]))).
writeTrsLamTy([Baum|Baeume],Einrueckung) :-
    nl,writeTrLamTy(Baum,Einrueckung),
    writeTrsLamTy(Baeume,Einrueckung).
writeTrsLamTy([],_).

writeTrLamTy([],Einrueckung) :-
    tab(Einrueckung), writeq([]).
writeTrLamTy([Wurzel|Bs],Einrueckung) :-
    ( sem([Wurzel|Bs],_)  % Ausdruck mit Bedeutungen
    ->  % schreibe alle Bedeutungen unter die Wurzel
        tab(Einrueckung),writeq(Wurzel),
        (Bs = [[Blatt]] -> tab(1), writeq(Blatt) ; true),
        (sem([Wurzel|Bs],LamTerm),
            type([],LamTerm,LamTermGetypt,Typ),
            Term = (LamTermGetypt:Typ),
            (nl,tab(Einrueckung),write('+ '),writen(Term)),
            fail             
        ; true)
    ; % schreibe das bedeutungslose Wort
      tab(Einrueckung),writeq(Wurzel) ),   
    ( Bs = [[Blatt]] -> true % schon geschrieben
    ; Einrueckung2 is Einrueckung + 3,
        writeTrsLamTy(Bs,Einrueckung2) ).
writeTrLamDrs([Wurzel|Bs],Einrueckung) :-
    ( drs:sem([Wurzel|Bs],_)  % Ausdruck mit Bedeutungen
    ->  % schreibe alle Bedeutungen unter die Wurzel
        tab(Einrueckung),writeq(Wurzel),
        (Bs = [[Blatt]] -> tab(1), writeq(Blatt) ; true),
         (drs:sem([Wurzel|Bs],LamDrs),
         (nl,tab(Einrueckung),write('+ '),writen(LamDrs)),
         fail             
        ; true)
    ; % schreibe das bedeutungslose Wort
      tab(Einrueckung),writeq(Wurzel) ),   
    ( Bs = [[Blatt]] -> true % schon geschrieben
    ; Einrueckung2 is Einrueckung + 3,
        writeTrsLamDrs(Bs,Einrueckung2) ).
writeTrLamDrs([],Einrueckung) :-
    tab(Einrueckung), writeq([]).
    
writeTrsLamDrs([Baum|Baeume],Einrueckung) :-
    nl,writeTrLamDrs(Baum,Einrueckung),
    writeTrsLamDrs(Baeume,Einrueckung).
writeTrsLamDrs([],_).

writeTrLamDrsTy([Wurzel|Bs],Einrueckung) :-
    ( drs:sem([Wurzel|Bs],_)  % Ausdruck mit Bedeutungen
    ->  % schreibe alle Bedeutungen unter die Wurzel
        tab(Einrueckung),writeq(Wurzel),
        (Bs = [[Blatt]] -> tab(1), writeq(Blatt) ; true),
        (drs:sem([Wurzel|Bs],LamTerm),
            drs:type([],LamTerm,LamTermGetypt,Typ),
            Term = (LamTermGetypt:Typ),
            (nl,tab(Einrueckung),write('+ '),writen(Term)),
            fail             
        ; true)
    ; % schreibe das bedeutungslose Wort
      tab(Einrueckung),writeq(Wurzel) ),   
    ( Bs = [[Blatt]] -> true % schon geschrieben
    ; Einrueckung2 is Einrueckung + 3,
        writeTrsLamDrsTy(Bs,Einrueckung2) ).
writeTrLamDrsTy([],Einrueckung) :-
    tab(Einrueckung), writeq([]).

writeTrsLamDrsTy([Baum|Baeume],Einrueckung) :-
    nl,writeTrLamDrsTy(Baum,Einrueckung),
    writeTrsLamDrsTy(Baeume,Einrueckung).
writeTrsLamDrsTy([],_).

% formatn('Schreibe Terme ~w und ~w mit lesbaren Variablen.',
%         [f(B,B),g(A,_,_G356)]).
formatn(Atom,Args) :-
    \+ \+((numbervars(Args,0,_),
           atomic_list_concat(Atoms,'~w',Atom),
           atomic_list_concat(Atoms,'~W',AtomNew),
           addNumVars(Args,ArgsNew),
           format(AtomNew,ArgsNew))).
addNumVars([],[]).
addNumVars([Arg|Args],[Arg,[numbervars(true)]|ArgsNew]) :-
    addNumVars(Args,ArgsNew).

