:- style_check(-discontiguous).
:- [grammatik], 
   ['Semantik/lambdaTerme.pl',
    'Semantik/sem.pl'
    ].                         

parses :-
    write('Beende die Eingabe mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    startsymbol(S),
    addTree:translate(S,Term,[Baum]),
    addDifflists:translate(Term,ExpTerm,Atomlist,[]),
    nl,write('Aufruf: '), portray_clause(ExpTerm),
    call(ExpTerm), write('Baum:   '),
    nl,writeTrLam(Baum,4),nl, 
    fail.
parses.

parses(Dateiname) :-   % Bedeutung für alle Ausdrücke in
   open(Dateiname,read,Strom),     % der Datei berechnen
   parses2(Strom),
   close(Strom), nl, write('Fertig.').
parses2(Strom) :-
   read_sentence(Strom, Satz, []),
   (Satz = [] -> true  % Dateiende 
   ; tokenize(Satz,Atome),nl,writeq(Atome),nl,
       (setof(Baum,tokenizer:parse(Atome,Baum),Trees)
       -> writeTrsLam(Trees,3), nl
       ; nl, tab(3),
           write('* keine Analysen gefunden *'),nl),
       parses2(Strom)   % weitere Sätze
   ).

:- ['Semantik/type.pl'].
parsest :-
    write('Beende die Eingabe mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    startsymbol(S),
    addTree:translate(S,Term,[Baum]),
    addDifflists:translate(Term,ExpTerm,Atomlist,[]),
    nl,write('Aufruf: '), portray_clause(ExpTerm),
    call(ExpTerm), write('Baum:   '),
    nl,writeTrLamTy(Baum,4),nl, 
    fail.
parsest.

parsest(Dateiname) :- % Typsemantik aller Sätze der Datei
   open(Dateiname,read,Strom),
   parsest2(Strom),
   close(Strom),nl,write('Fertig.').
parsest2(Strom) :-
   read_sentence(Strom, Satz, []),
   (Satz = [] -> true  % Dateiende 
   ; tokenize(Satz,Atome),
       nl,writeq(Atome),nl,
       (setof(Baum,tokenizer:parse(Atome,Baum),Trees)
       -> writeTrsLamTy(Trees,3), nl
       ; nl, tab(3),
           write('* keine Analysen gefunden *'), nl),
       parsest2(Strom)   % weitere Sätze
   ).

:- ['Semantik/auswertung.pl'].

frage :- write('Beende die Frage mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    Startsymbol = s([qu],[_Temp,ind,Vst]),
    parse(Startsymbol,Atomlist,Baum,ExpTerm),
    (call(ExpTerm) ->
        (sem(Baum,LamTerm) -> % nur erste Bedeutung!
            (Vst = ve -> beantworte(LamTerm,Wert)
            ; antworten(LamTerm,Wert)),
            nl,write('Antwort: '),write(Wert)
        ; write('\nÜbersetzung Frage->Formel fehlt.'),
            nl,nl,write('Baum:   '), writeq(Baum)
        )
    ; nl, write('\nEingabe syntaktisch nicht erkannt.\n')
    ).

parse(Startsymbol,Atomlist,Baum,ExpTerm) :-
    addTree:translate(Startsymbol,Term,[Baum]),
    addDifflists:translate(Term,ExpTerm,Atomlist,[]),
    nl,write('Aufruf: '), portray_clause(ExpTerm).
% Abkürzung:
semTy(Baum,LamTermTyped) :-
    sem(Baum,LamTerm),
    type([],LamTerm,LamTermTyped,_Type).
fraget :- write('Beende die Frage mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    Startsymbol = s([qu],[_Temp,ind,Vst]),
    parse(Startsymbol,Atomlist,Baum,ExpTerm),
    (call(ExpTerm) ->
        (semTy(Baum,LamTerm)  % nur erste Bedeutung!
        -> (Vst = ve -> beantworte([],LamTerm,Wert)
            ; antworten([],LamTerm,Wert)),
            nl,write('Antwort: '),write(Wert)
        ; write('\nÜbersetzung Frage->Formel fehlt.'),
            nl,nl,write('Baum:   '), writeq(Baum)
        )
    ; nl, write('\nEingabe syntaktisch nicht erkannt.\n')
    ).
beantworte(Env,Aussage,Wert) :-
    eval(Env,Aussage) -> Wert = ja ; Wert = nein.

antworten(Env,qu(V:Ty,Restr,Formel), Objekte) :-
    var(V),!,
    findall(O,(objekt(O:Ty),
               eval([(V,O)|Env],(Restr & Formel))),Os),
    sort(Os,Objekte).

antworten(Env,qu((X,Y):(TyX*TyY),Restr,Formel),Paare) :-
    !, findall((A,B),(objekt(A:TyX),objekt(B:TyY),
         eval([(X,A),(Y,B)|Env],(Restr & Formel))),ABs),
    sort(ABs,Paare).

:- ['Semantik/semDrs.pl']. % Laden der DRS-Semantik sem/2.

parsedrs :-
    write('Beende die Eingabe mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    startsymbol(S),
    addTree:translate(S,Term,[Baum]),
    addDifflists:translate(Term,ExpTerm,Atomlist,[]),
    nl,write('Aufruf: '), portray_clause(ExpTerm),
    call(ExpTerm), write('Baum:   '),
    nl,writeTrLamDrs(Baum,4),nl, 
    fail.
parsedrs.

parsedrs(Dateiname) :- % DRS-Semantik der Sätze der Datei
   open(Dateiname,read,Strom),
   parsedrs2(Strom),
   close(Strom),nl,write('Fertig.').
parsedrs2(Strom) :-
   read_sentence(Strom, Satz, []),
   (Satz = [] -> true  % Dateiende 
   ; tokenize(Satz,Atome),nl,writeq(Atome),nl,
       (setof(Baum,tokenizer:parse(Atome,Baum),Trees)
       -> writeTrsLamDrs(Trees,3), nl
       ; nl, tab(3),
           write('* keine Analysen gefunden *'), nl),
       parsedrs2(Strom)   % weitere Sätze
   ).

% DRS-Semantik: normalisieren und mergen
:- ['Semantik/lambdaDrs.pl'].
% Typisierung von (merge-freien) Lambda-DRSen 
:- ['Semantik/typeDrs.pl'].

parsedrst :-
    write('Beende die Eingabe mit <Punkt><Return>'),
    nl,read_sentence(user,Sentence,[]),
    tokenize(Sentence,Atomlist),
    startsymbol(S),
    addTree:translate(S,Term,[Baum]),
    addDifflists:translate(Term,ExpTerm,Atomlist,[]),
    nl,write('Aufruf: '), portray_clause(ExpTerm),
    call(ExpTerm), write('Baum:   '),
    nl,writeTrLamDrsTy(Baum,4),nl, 
    fail.
parsedrst.

